program mandelpas_asm;
{$G+,N+,E-}
uses graph, dos, Crt;

var
  graphdriver, graphmode, i, j, n: integer;
  a, b, lp1, lp2: single;
const
  cnst4: single = 4;
  maxi: integer = 1000;

function iterate(re, im: single): integer; assembler;
asm
         fld dword ptr re
         fld dword ptr im
         fld dword ptr cnst4;
         xor bx,bx
         fldz
         fldz
         fldz
         fldz
        fmul st,st(3)
@iter:  fadd st,st(0)
        fadd st,st(5)
        fincstp
        fsub st,st(1)
        fadd st,st(5)
        fst  st(2)
        fmul st,st(0)
        inc  bx
        fst  st(6)
        fdecstp
        fst  st(2)
        fmul st(2),st
        fdecstp
        fadd st,st(3)
        fcomp st(5)
        fnstsw ax
        and ah,41H
        fmul st,st(3)
        jz @ok
        cmp bx,maxi
        jb @iter
@ok:
        fcompp
        fcompp
        fcompp
        fstp st(0)
        mov ax,bx
end;

begin
  graphdriver := InstallUserDriver('svga', nil);
  graphmode := 5;
  initgraph(graphdriver, graphmode, '');
  lp1 := 3.2 / 1024;
  lp2 := 2.4 / 768;
  b := -1.2;

  for i := 0 to 767 do
  begin
    if keypressed then closegraph;
    b := b + lp2;
    a := -2.4;

    for j := 0 to 1023 do
    begin
      a := a + lp1;

      n := iterate(a, b);

      if n < maxi then
      begin
        putpixel(j, i, n);
      end;
    end;
  end;
  {readln;}
  closegraph;

end.

