program mandelpas;
{$G+,N+,E-}
uses graph, dos, Crt;

var
  graphdriver, graphmode, i, j, n: integer;
  a, b, lp1, lp2: single;
const
  cnst4: single = 4;
  maxi: integer = 1000;

function iterate(re, im: single): integer;
var
	x, y, x2, y2: single;
	n: integer;
begin
  x := 0;
  y := 0;
  x2 := 0;
  y2 := 0;  
  n := 0;
  
  while (n < maxi) and ((x2 + y2) < cnst4) do
  begin
    y := 2 * x * y + im;
    x := x2 - y2 + re;    
    x2 := x * x;
    y2 := y * y;
    n := n + 1;
  end;
  
  iterate := n;
end;

begin
  graphdriver := InstallUserDriver('svga', nil);
  graphmode := 5;
  initgraph(graphdriver, graphmode, '');
  lp1 := 3.2 / 1024;
  lp2 := 2.4 / 768;
  b := -1.2;

  for i := 0 to 767 do
  begin
    if keypressed then closegraph;
    b := b + lp2;
    a := -2.4;

    for j := 0 to 1023 do
    begin
      a := a + lp1;

      n := iterate(a, b);

      if n < maxi then
      begin
        putpixel(j, i, n);
      end;
    end;
  end;
  {readln;}
  closegraph;

end.

